/**
 * Created by AlexanderC on 6/15/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValidationSchemaNotFoundException = undefined;

var _Exception = require('./Exception');

class ValidationSchemaNotFoundException extends _Exception.Exception {
  /**
   * @param {String} schemaName
   */
  constructor(schemaName) {
    super(`Missing validation schema '${schemaName}'`);
  }
}
exports.ValidationSchemaNotFoundException = ValidationSchemaNotFoundException;