/**
 * Created by AlexanderC on 6/20/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidJoiSchemaException = undefined;

var _Exception = require('./Exception');

class InvalidJoiSchemaException extends _Exception.Exception {
  /**
   * @param {String} schemaName
   */
  constructor(schemaName) {
    super(`Invalid validation schema ${schemaName}. Object must be a Joi instance!`);
  }
}
exports.InvalidJoiSchemaException = InvalidJoiSchemaException;